<% 
'*******************************************************************
'******** Copyright (c) 2009 Asadal.Co.Ltd
'******** 최초 작업일 : 
'******** 최초 작업자 : 
'******** 최종 작업일 :
'******** 최종 작업자 :
'******** 파일명	: class.BASE64.asp
'******** 파일설명	: BASE64로 변환을 합니다.
'******** 수정설명	:
'*******************************************************************
' BASE64
'
'
' @usage 
' dim Base64
' set Base64 = new CBASE64
' str = Base64.encode("아사달")
' str = Base64.decode("S5jby5rcg==")

' Public Method
' Base64.encode(msg)
' Base64.decode(msg)

' ------------------------------------------------------------------------- 
' 타입에 따라 빈값인지 체크												  
' 파라미터 설명 :															  
'			- TempVar : 체크할 참조변수										  
' 반환값 : 빈값일 경우 true                                                 
' ------------------------------------------------------------------------- 
Private Function IsBlank(ByRef TempVar)
	IsBlank = False
	Dim tmpType
	Select Case VarType(TempVar) 
		Case 0, 1     'Empty & Null 
			 IsBlank = True
		Case 8     'String 
			 If Len(Trim(TempVar)) = 0 Then 
				IsBlank = True
			 End If 
		Case 9      'Object
			 tmpType = TypeName(TempVar) 
			 If (tmpType = "Nothing") Or (tmpType = "Empty") Then 
				IsBlank = True 
			 End If 
		Case 8192, 8204, 8209    'Array 
			 If UBound(TempVar) = -1 Then 
				IsBlank = True 
			 End If 
	  End Select 
End Function 


Class CBase64

	Private TBL_BASE64

	Private Sub Class_Initialize
		TBL_BASE64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
	End Sub


	' UNICODE -> ANSI
	Public Function Unicode2Ansi(byVal sMessage)
		Dim Len1
		Dim I, VarCHAR, VarASC, VarHEX, VarLOW, VarHIGH

		Len1 = LenB(sMessage)
		Unicode2Ansi = ""

		For I = 1 to Len1
			VarCHAR	= MidB(sMessage,I,1)
			VarASC	= AscB(VarCHAR)
			IF VarASC < 0 Then VarASC = VarASC + 65536
			IF VarASC > 255 Then
				VarHEX		 = Hex(VarASC)
				VarLOW		 = Left(VarHEX,2)
				VarHIGH		 = Right(VarHEX,2)
				Unicode2Ansi = Unicode2Ansi & ChrB("&H" & VarLOW ) & ChrB("&H" & VarHIGH )
			Else
				Unicode2Ansi = Unicode2Ansi & ChrB(VarASC)
			End IF
		Next
	End Function

	' ANSI -> UNICODE
	Public Function Ansi2Unicode(byVal sMessage)
		Dim Len1
		Dim VarCHAR, VarASC, I

		Len1 = LenB(sMessage)
		Ansi2Unicode = ""

		IF Len1=0 Then	Exit Function

		For I=1 To Len1
			VarCHAR	= MidB(sMessage,I,1)
			VarASC	= AscB(VarCHAR)
			IF VarASC > 127 Then
				Ansi2Unicode = Ansi2Unicode & ChrB(AscB(MidB(sMessage, I+1,1) & VarCHAR))
				I = I + 1
			Else
				Ansi2Unicode = Ansi2Unicode & ChrB(VarASC)
			End IF
		Next
	End function


	' ASCII -> BASE64
	Private Function Base64Encode(byVal sMessage)
		Dim aByte(), vm, vc, rs
		Dim n, i, k, s, c1, c2, c3, c4

		n = Len(sMessage)
		if n = 0 then Exit Function
		k = 0

		For i = 1 to n
			s = Asc(Mid(sMessage,i,1))
			if (s AND &HFF00) <> 0 Then	
				Redim Preserve aByte(k)
				aByte(k) = ((s AND &HFF00) / &H100 ) AND &HFF
				k = k + 1
				Redim Preserve aByte(k)
				aByte(k) = (s AND &HFF)
			else
				Redim Preserve aByte(k)
				aByte(k) = s
			end if
			k = k + 1
		Next
		vm = (UBound(aByte)+1) Mod 3
		vc = (UBound(aByte)+1) \ 3

		if vm > 0 then
			Redim Preserve aByte(k)
			aByte(k) = 0
		end if

		'=============== 주 연산 =========================

		For i = 0 to Ubound(aByte) Step 3
			c1 = Mid(TBL_BASE64, ((aByte(i) AND &HFC ) / &H4) + 1, 1)
			c2 = Mid(TBL_BASE64, (((aByte(i) AND &H3) * &H10) OR ((aByte(i+1) AND &HF0) / &H10)) + 1, 1)
			if ((i/3) = vc) AND (vm = 1) then
				c3 = "="
				c4 = "="
			elseif (i/3 = vc) AND (vm = 2) then
				c3 = Mid(TBL_BASE64, (((aByte(i+1) AND &HF) * &H4) OR ((aByte(i+2) AND &HC0) / &H40)) + 1, 1)
				c4 = "="
			else
				c3 = Mid(TBL_BASE64, (((aByte(i+1) AND &HF) * &H4) OR ((aByte(i+2) AND &HC0) / &H40)) + 1, 1)
				c4 = Mid(TBL_BASE64, (aByte(i+2) AND &H3F) + 1, 1)
			end if	
			rs = rs & c1 & c2 & c3 & c4
		Next

		Base64Encode = rs
	End Function

	' BASE64 -> ASCII
	Private Function Base64Decode(byVal sMessage)
		Dim aByte(), rs
		Dim i, k, lsGroup64, c1, c2, c3, c4, Byte1, Byte2, Byte3

		sMessage = replace(sMessage,chr(10),"")
		sMessage = replace(sMessage,chr(13),"")
		k = -1

		If Len(sMessage) Mod 4 > 0 Then sMessage = sMessage & String(4 - (Len(sMessage) Mod 4), " ")  

		'=============== 주 연산 =========================

		For i = 1 To Len(sMessage) Step 4  
			lsGroup64 = Mid(sMessage, i, 4)
			c1 = InStr(TBL_BASE64, Mid(lsGroup64, 1, 1)) - 1  
			c2 = InStr(TBL_BASE64, Mid(lsGroup64, 2, 1)) - 1  
			c3 = InStr(TBL_BASE64, Mid(lsGroup64, 3, 1)) - 1  
			c4 = InStr(TBL_BASE64, Mid(lsGroup64, 4, 1)) - 1  
			Byte1 = (((c2 And 48) \ 16) Or (c1 * 4)) And &HFF
			Byte2 = (((c3 And 60) \ 4) Or (c2 * 16)) And &HFF
			Byte3 = (((c3 And 3) * 64) And &HFF) Or (c4 And 63)
			if c4 < 0 then Byte3 = -1
			if c3 < 0 then Byte2 = -1

			k = k + 3
			Redim Preserve aByte(k)

			aByte(k-2) = Byte1
			aByte(k-1) = Byte2
			aByte(k) = Byte3
		Next

		for i = 0 to UBound(aByte)
			if aByte(i) > 0 then
				if aByte(i) > 127 then
					rs = rs & Chr((aByte(i) * &H100) + aByte(i+1))
					i = i + 1
				else
					rs = rs & Chr(aByte(i))
				end if
			end if
		next

		Base64Decode = rs
	End Function


	' ASCII -> BASE64
	Public Function encode(byVal sMessage)
		If IsBlank(sMessage) Then 
		 encode = ""
		 Exit Function
		End If 
		encode = Base64Encode( sMessage )
	End Function

	' BASE64 -> ASCII
	Public Function decode(byVal sMessage)
		If IsBlank(sMessage) Then 
		 decode = ""
		 Exit Function
		End If 
		decode = Base64Decode( sMessage&"" )
	End Function

End Class
Dim Base64 : Set Base64 = new CBase64


Class AsadalSMS 
	Private m_strHost
	Private m_nPort
	Private m_nHeader
	Private m_strUserID
	Private m_strUserPW
	Private m_strFrom
	Private m_strPhone
	Private m_strMsg
	Private m_strReserve
	Private m_nTimeOut
	Private m_strLastError
	Private m_nLastErrorNo
	Private m_bDebug

	Private m_objSocket 

	Sub Class_Initialize()
		' 초기화
		Host =  "daemon.asadal.com"
		Port = "7787"
		Header = "1"
		Reserve = "000000000000"
		TimeOut = 5000

		LastErrorNo = 0

		Call Open()
	End Sub 

	Sub Class_Terminate()
		If IsObject(m_objSocket) Then 
			m_objSocket.Close()
		End If 

		Set m_objSocket = Nothing 
	End Sub 

	Private Function Connect()
		Set m_objSocket = CreateObject("Socket.TCP")
		With m_objSocket
			.Host = Host & ":" & Port
			If TimeOut > 0 Then 
				.TimeOut = TimeOut
			End If 
			Call .Open()
		End With
		If Err.Number <> 0 Then 
			Connect = False 
			LastError = Err.Message
			Err.Raise 1, , LastError
			'Exit Function 
		End If 

		Connect = True 
	End Function 

	Public Property Let Host(ByVal value)
		m_strHost = value
	End Property 
	
	Public Property Get Host()
		Host = m_strHost
	End Property 

	Public Property Let Port(ByVal value)
		m_nPort = value
	End Property 
	
	Public Property Get Port()
		Port = m_nPort
	End Property 

	Public Property Let Header(ByVal value)
		m_nHeader = value
	End Property 
	
	Public Property Get Header()
		Header = m_nHeader
	End Property 

	Public Property Let UserID(ByVal value)
		m_strUserID = value
	End Property 
	
	Public Property Get UserID()
		UserID = m_strUserID
	End Property 

	Public Property Let UserPW(ByVal value)
		m_strUserPW = value
	End Property 
	
	Public Property Get UserPW()
		UserPW = m_strUserPW
	End Property 

	Public Property Let From(ByVal value)
		m_strFrom = value
	End Property 
	
	Public Property Get From()
		From = m_strFrom
	End Property 

	Public Property Let Phone(ByVal value)
		m_strPhone = value
	End Property 
	
	Public Property Get Phone()
		Phone = m_strPhone
	End Property 

	Public Property Let Reserve(ByVal value)
		m_strReserve = value
	End Property 
	
	Public Property Get Reserve()
		Reserve = m_strReserve
	End Property

	Public Property Let Msg(ByVal value)
		m_strMsg = value
	End Property 
	
	Public Property Get Msg()
		Msg = m_strMsg
	End Property 

	Private Property Let LastError(value)
		m_strLastError = value
	End Property 

	Public Property Get LastError()
		LastError = m_strLastError
	End Property 

	Public Property Get LastErrorNo()
		LastErrorNo = m_nLastErrorNo
	End Property 

	Private Property Let LastErrorNo(value)
		m_nLastErrorNo = value
	End Property 

	Public Property Let Debug(value)
		m_bDebug = value
	End Property 

	Public Property Get Debug()
		Debug = m_bDebug
	End Property 

	Public Property Get Socket()
		Set Socket = m_objSocket
	End Property 
'
'	Public Property Let AddPacket(key, value)
'		If key = "header" Then 
'			mPacket("header") = (value)
'		ElseIf key = "id" Then
'			mPacket("id") = Lpad(value, " ", 20)
'		ElseIf key = "pw" Then 
'			mPacket("pw") = Lpad(value, " ", 20)
'		ElseIf key = "reserve" Then 
'			mPacket("reserve") = Lpad(value, " ", 12)
'		ElseIf key = "from" Then 
'			mPacket("from") = Lpad(value, " ", 15)
'		ElseIf key = "msg" Then 
'			mPacket("msg") = (strAnsi2Unicode(Base64encode(strUnicode2Ansi(value))))
'		ElseIf key = "phone" Then 
'			mPacket("phone") = value
'		End If 
'	End Property 

	Private Function Base64Encode(str)
		Base64Encode =  (Base64.encode((str)))
	End Function 

	Public Function MakePacket()
		Dim msgphone : msgphone = Base64Encode(Msg) & "," & Phone
		Dim strLen : strLen = Lpad(Len(msgphone), " ", 8)
		
		MakePacket = Header & Lpad(UserID, " ", 20) & Lpad(UserPW, " ", 20) & Lpad(Reserve, " ", 12) & Lpad(From, " ", 15) & strLen & msgphone
	End Function 

	Public Function Open()
		Open = Connect()
	End Function 

	Private Function Check()
		Check = False 

		Dim value : value = Trim(Port)
		If Not IsNumeric(value) Then 
			LastErrorNo = 10001
			LastError = "포트번호가 잘못 되었습니다."
			Exit Function 	
		End If 

		value = CInt(Trim(Header))
		If Not (value = 1 Or value = 2) Then 
			LastErrorNo = 1002
			LastError = "헤더값이 유효하지 않은 값입니다.(1 or 2)"
			Exit Function 
		End If 

		value = Trim(UserID)
		If Len(value) > 20 Then 
			LastErrorNo = 1003
			LastError = "ID 길이가 너무 깁니다."
			Exit Function 
		End If 

		value = Trim(UserPW)
		If Len(value) > 20 Then 
			LastErrorNo = 1004
			LastError = "암호 길이가 너무 깁니다."
			Exit Function 
		End If 

'		value = GetOnlyNumber(Trim(From))
'		If Not CheckNumber(value) Then 
'			LastErrorNo = 1005
'			LastError = "보내는 사람의 번호가 잘못되었습니다."
'			Exit Function 
'		End If 

		value = GetOnlyNumber(Trim(Phone))
		If Not CheckNumber(value) Then 
			LastErrorNo = 1006
			LastError = "받는 사람의 번호가 잘못되었습니다."
			Exit Function  
		End If 

		value = GetOnlyNumber(Trim(Reserve))
		If Len(value) <> 12 Then 
			LastErrorNo = 1007
			LastError = "예약시간이 유효하지 않습니다.(200912120912)"
			Exit Function  
		End If 

		Check = true
	End Function 

	Public Function  Send()
		' 값 유효성 체크
		If Not Check() Then 
			Err.Clear
			Err.Raise LastErrorNo, , LastError
		End If 

		' 패킷 문자열 조합
		packet = MakePacket()
		If Debug Then 
			Response.Write "<br>Packet(" & Host & ":" & Port & "): " & packet & "<br>"
		End If 
		m_objSocket.SendText(packet)
		m_objSocket.WaitForDisconnect()


		If Debug Then 
			Response.Write "<br>Result : " & m_objSocket.Buffer & "<br>"
		End If 
        Send = m_objSocket.Buffer

		If Err.Number <> 0 Then 
			LastError = "Send Error"
			Err.Raise 1000, , LastError
		End If 
	End Function 

	Private Function Lpad (MyValue, MyPadChar, MyPaddedLength)
		Lpad = string(MyPaddedLength - Len(MyValue),MyPadChar) & MyValue
	End Function

	Private Function CheckNumber(no)
		CheckNumber = False
		
		If IsBlank(no) Then Exit Function 

		Dim Res : Res = ParseNumber(no)
		If Res(0) <> 0 Then 
			Exit Function 
		End If
		CheckNumber = True 
	End Function 

	' 휴대폰 번호 파싱
	Private Function ParseNumber(ByVal no)
		Dim result(4)

		Dim length : length = Len(no)
		Dim num : num = no
		Dim  num1, num2, num3, i, ch
		Dim errorCode : errorCode = 0
		
		if length < 10 Or length>11 Then 
			errorCode = 1
		Else
			num1 = Mid(num, 1, 3)
			num2 = Mid(num, 4, length - 7 )
			num3 = Right(num, 4)

			If num1 <> "010" and num1 <> "011" and num1 <> "016" and num1 <> "017" and num1 <> "018" and num1 <> "019"  Then 
				errorCode = 2
			Else
				If Not IsNumeric(num) Then 
					errorCode = 3
				End If 
			End If 
		End If 
		
		result(0) = errorCode
		result(1) = num1
		result(2) = num2
		result(3) = num3
		
		ParseNumber = result

	End Function 

	' 숫자 이외의 문자를 삭제
	Private Function GetOnlyNumber(ByVal no)
		Dim i, tmp 
		GetOnlyNumber = ""
		no = no & ""
		For i = 1 To Len(no)
			tmp = Mid(no, i, 1)
			If IsNumeric(tmp) Then 
				GetOnlyNumber = GetOnlyNumber & tmp
			End If 
		Next 
	End Function  

    ' php array를 asp의 dictionary형식으로 변환
    Public Function ParseResult(ByVal result)
        Dim objD
        Set objD = CreateObject("Scripting.Dictionary")

        Dim tmp1, tmp2, tmp3, key, val
        result = Trim(result)
        result = Mid(result, InStr(result, "{") + 1)
        result = Left(result, InStr(result, "}"))

        tmp1 = Split(result, ";")
        For i=0 To UBound(tmp1)-2 Step 2
            tmp2 = Split(tmp1(i), ":")
            tmp3 = Split(tmp1(i+1), ":")
            If UBound(tmp2) = 2 And UBound(tmp3) = 2 Then 
                key = Replace(tmp2(2), """", "")
                val = Replace(tmp3(2), """", "")
                objD.Add key, val
            End If 
        Next 

        Set ParseResult = objD
    End Function 

End Class
%>